Loading...
Searching...
No Matches
ASSA::Singleton< T > Class Template Reference

`#include <Singleton.h>`

## Static Public Member Functions

static T * | get_instance ()
| Return an instance of templated class T.

## Protected Member Functions

| Singleton ()
| Protected Constructor.
virtual | ~Singleton ()
| Virtual Destructor.

## Static Private Attributes

static T * | m_instance
| Pointer to the object T instance.
static Destroyer< T > | m_destroyer
| Destroyer that owns object T.

## Friends

class | Destroyer< T >

## Detailed Description

template<class T>
class ASSA::Singleton< T >

Definition at line 42 of file Singleton.h.

## Constructor & Destructor Documentation

## Singleton()

template<class T >

ASSA::Singleton< T >::Singleton | ( |  | ) |

inline protected

Protected Constructor.

Definition at line 57 of file Singleton.h.

{}

## ~Singleton()

template<class T >

virtual ASSA::Singleton< T >::~Singleton | ( |  | ) |

inline protected virtual

Virtual Destructor.

Definition at line 62 of file Singleton.h.

{}

## Member Function Documentation

## get_instance()

template<class T >

static T * ASSA::Singleton< T >::get_instance | ( |  | ) |

inline static

Return an instance of templated class T.

Definition at line 47 of file Singleton.h.

{
if (m_instance == 0) {
m_instance = new T;
m_destroyer.setGuard (m_instance);
}
return m_instance;
}
ASSA::Singleton::m_destroyer
static Destroyer< T > m_destroyer
Destroyer that owns object T.
Definition Singleton.h:69
ASSA::Singleton::m_instance
static T * m_instance
Pointer to the object T instance.
Definition Singleton.h:66

References ASSA::Singleton< T >::m_destroyer, and ASSA::Singleton< T >::m_instance.

## Friends And Related Symbol Documentation

## Destroyer< T >

template<class T >

friend class Destroyer< T >

friend

Definition at line 57 of file Singleton.h.

## Member Data Documentation

## m_destroyer

template<class T >

Destroyer<T> ASSA::Singleton< T >::m_destroyer

static private

Destroyer that owns object T.

Definition at line 69 of file Singleton.h.

Referenced by ASSA::Singleton< T >::get_instance().

## m_instance

template<class T >

T* ASSA::Singleton< T >::m_instance

static private

Pointer to the object T instance.

Definition at line 66 of file Singleton.h.

Referenced by ASSA::Singleton< T >::get_instance().

The documentation for this class was generated from the following file:

- Singleton.h